﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Windows
Imports System.Windows.Controls

Namespace MiddlemarchReader
    Public MustInherit Class PageTransition
        Inherits DependencyObject
        Public Shared ReadOnly FractionalBaseIndexProperty As DependencyProperty = DependencyProperty.Register("FractionalBaseIndex", GetType(Double), GetType(PageTransition), New PropertyMetadata(-1.0, AddressOf OnTransitionChanged))

        Public Property FractionalBaseIndex() As Double
            Set(ByVal value As Double)
                SetValue(FractionalBaseIndexProperty, value)
            End Set
            Get
                Return CDbl(GetValue(FractionalBaseIndexProperty))
            End Get
        End Property

        Public Overridable ReadOnly Property AnimationDuration() As Double
            Get
                Return 1000
            End Get
        End Property

        Private Shared Sub OnTransitionChanged(ByVal obj As DependencyObject, ByVal args As DependencyPropertyChangedEventArgs)
            TryCast(obj, PageTransition).OnTransitionChanged(args)
        End Sub

        Private Sub OnTransitionChanged(ByVal args As DependencyPropertyChangedEventArgs)
            Dim fraction As Double = (3 + Me.FractionalBaseIndex) Mod 1
            Dim baseIndex As Integer = CInt(3 + Me.FractionalBaseIndex - fraction) Mod 3
            ShowPageTransition(baseIndex, fraction)
        End Sub

        Public MustOverride Sub Attach(ByVal containerPanel As Panel, ByVal pageContainer0 As FrameworkElement, ByVal pageContainer1 As FrameworkElement, ByVal pageContainer2 As FrameworkElement)

        Public MustOverride Sub Detach()

        Protected MustOverride Sub ShowPageTransition(ByVal baseIndex As Integer, ByVal fraction As Double)
    End Class
End Namespace