﻿Imports System
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Media

Namespace MiddlemarchReader
    Public Class SlideTransition
        Inherits PageTransition
        Private pageContainers(2) As FrameworkElement
        Private translateTransforms(2) As TranslateTransform

        Public Overrides ReadOnly Property AnimationDuration() As Double
            Get
                Return 500
            End Get
        End Property

        Public Overrides Sub Attach(ByVal containerPanel As Panel, ByVal pageContainer0 As FrameworkElement, ByVal pageContainer1 As FrameworkElement, ByVal pageContainer2 As FrameworkElement)
            pageContainers(0) = pageContainer0
            pageContainers(1) = pageContainer1
            pageContainers(2) = pageContainer2

            For i As Integer = 0 To 2
                translateTransforms(i) = New TranslateTransform()
                pageContainers(i).RenderTransform = translateTransforms(i)
            Next i
        End Sub

        Public Overrides Sub Detach()
            For Each pageContainer As FrameworkElement In pageContainers
                pageContainer.RenderTransform = Nothing
            Next pageContainer
        End Sub

        Protected Overrides Sub ShowPageTransition(ByVal baseIndex As Integer, ByVal fraction As Double)
            Dim nextIndex As Integer = (baseIndex + 1) Mod 3
            Dim prevIndex As Integer = (baseIndex + 2) Mod 3

            translateTransforms(baseIndex).X = -fraction * pageContainers(prevIndex).ActualWidth
            translateTransforms(nextIndex).X = translateTransforms(baseIndex).X + pageContainers(baseIndex).ActualWidth
            translateTransforms(prevIndex).X = translateTransforms(baseIndex).X - pageContainers(prevIndex).ActualWidth
        End Sub
    End Class
End Namespace